/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cgl2d class


*******************************************************************************
******************************************************************************/


#include <nds.h>

#include "Cglsprite.h"
#include "Cgl2d.h"

/******************************************************************************


******************************************************************************/
void Cgl2d::init()
{

	glInit();
	glViewport(0,0,255,191);
	
	glClearColor(0,0,0,31);
	glClearDepth(GL_MAX_DEPTH);

}

/******************************************************************************


******************************************************************************/
// issue this before drawing 2d
void Cgl2d::start()
{
	// save 3d matrices
	glMatrixMode(GL_PROJECTION);   
    glPushMatrix();
	
	glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
	
	// what?!! No glDisable(GL_DEPTH_TEST)?!!!!!!
	
	glEnable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_ANTIALIAS);
	glDisable(GL_OUTLINE);

	glColor(0x7FFF); 
	
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK);

	viewortho();
	
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	// set initial z-coord to 0
	// so that we only call GFX_VERTEX_XY.
	// An optimization trick ;*)
	depth = 0;
	glColor3b(0,0,0);
	glBegin(GL_TRIANGLES);
	
		glVertex3i(-10,-10,0);
		
		glVertex2i(-10,-10);
		
		glVertex2i(-10,-10);
		
	glEnd();
	
	glColor(0x7FFF);

}

/******************************************************************************


******************************************************************************/
// issue this after drawing 2d so that we don't mess the matrix stack
void Cgl2d::end()
{

	// restore 3d matrices
	glMatrixMode(GL_PROJECTION);    
    glPopMatrix(1);
	glMatrixMode(GL_MODELVIEW);
    glPopMatrix(1);

}

/******************************************************************************


******************************************************************************/
void Cgl2d::viewortho()
{

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrthof32(0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, -512, 1 << 12);

}


/******************************************************************************


******************************************************************************/
// sets the z-coord 
// to emulate drawing priority
void Cgl2d::increase_depth()
{
	
	depth++;
	
	// set initial z-coord to depth
	// so that we only call GFX_VERTEX_XY.
	// An optimization trick ;*)
	glColor3b(0,0,0);
	glBegin(GL_TRIANGLES);
	
		glVertex3i(-10,-10,depth);
		
		glVertex2i(-10,-10);
		
		glVertex2i(-10,-10);
		
	glEnd();
	
	glColor(0x7FFF);

}

/******************************************************************************


******************************************************************************/
void Cgl2d::load_texture(int &textureID,GL_TEXTURE_TYPE_ENUM type, int sizeX, int sizeY, const uint8* texture)
{

	glGenTextures(1, &textureID);
	glBindTexture(0, textureID);
	glTexImage2D( 0, 0, type, sizeX, sizeY, 0, GL_TEXTURE_WRAP_S|GL_TEXTURE_WRAP_T|GL_TEXTURE_COLOR0_TRANSPARENT, texture );
	
}


/******************************************************************************


******************************************************************************/
void Cgl2d::init_sprites(Cglsprite *sprite,int numframes, const unsigned int *texcoords, int textureID)
{

	// init sprites texture coords and texture ID
	for (int i=0; i < numframes; i++)
	{
		int j = i * 4; // texcoords array is u_off, wid, hei
		sprite[i].textureID = textureID;
		sprite[i].u_off = texcoords[j];				// set x-coord
		sprite[i].v_off = texcoords[j+1];;			// y-coord 
		sprite[i].width = texcoords[j+2];			// don't decrease because NDS 3d core does not draw last vertical texel
		sprite[i].height = texcoords[j+3]-1;		// sub 1 since glsprite.render expects height-1
	}
	
}


/******************************************************************************


******************************************************************************/
// draws a filled box
void Cgl2d::box_fill(s32 x1, s32 y1, s32 x2, s32 y2, s32 color)
{
	
	glColor(color);
	glBegin(GL_QUADS);
		glVertex2i(x1,y1);
		glVertex2i(x1,y2);
		glVertex2i(x2,y2);
		glVertex2i(x2,y1);
	glEnd();
	
}

/******************************************************************************

	draws a line

******************************************************************************/
void Cgl2d::line(s32 x1, s32 y1, s32 x2, s32 y2, s32 color)
{

	glColor(color);
	glBegin(GL_TRIANGLES);
		glVertex2i(x1,y1);
		glVertex2i(x2,y2);
		glVertex2i(x2,y2);
	glEnd();
	
}

/******************************************************************************


******************************************************************************/
// draws a box
void Cgl2d::box(s32 x1, s32 y1, s32 x2, s32 y2, s32 color)
{
		
	glColor(color);
	glBegin(GL_TRIANGLES);
	
		glVertex2i(x1,y1);
		glVertex2i(x2,y1);
		glVertex2i(x2,y1);

		glVertex2i(x2,y1);
		glVertex2i(x2,y2);
		glVertex2i(x2,y2);

		glVertex2i(++x2,y2);  // bug fix for lower-right corner disappearing pixel
		glVertex2i(x1,y2);
		glVertex2i(x1,y2);

		glVertex2i(x1,y2);
		glVertex2i(x1,y1);
		glVertex2i(x1,y1);
		
	glEnd();
		
}

